rates<-function(tree,data,name){
  names(data)<-name
  WNfit <-fitContinuous (tree, data, model="white")
  BMfit <-fitContinuous (tree, data, model="BM")
  OUfit <-fitContinuous (tree, data, model="OU") 
  LAfit <-fitContinuous (tree, data, model="lambda")
  AIC1 <-cbind.data.frame(WN=WNfit$opt$aic, BM=BMfit$opt$aic, OU=OUfit$opt$aic,LA=LAfit$opt$aic) 
  OU1tree<-rescale(tree,model='OU',alpha=OUfit$opt$alpha)
  LA1tree<-rescale(tree,model='lambda',lambda=LAfit$opt$lambda)
  
  BM1rec<-ace(data,tree,type="continuous",method="GLS",corStruct=corBrownian(1,tree))
  OU1rec<-ace(data,OU1tree,type="continuous",method="GLS",corStruct=corBrownian(1,OU1tree))
  LA1rec<-ace(data,LA1tree,type="continuous",method="GLS",corStruct=corBrownian(1,LA1tree))
  BMace1 <- BM1rec$ace
  OUace1 <- OU1rec$ace
  LAace1 <- LA1rec$ace
  Brtime <- branching.times(tree)
  ACE <- cbind(Brtime,BMace1,OUace1,LAace1) 
  edge0 <- data.frame(tree$edge)
  edge1 <- edge0[order(edge0$X2),]#order by latest node/tips
  mrca<-edge1[edge1$X2<=length(tree$tip.label),]#only get the edges connect with tips
  rownames(ACE)<-c((length(tree$tip.label)+1):(length(tree$tip.label)*2-1))#set prior nodes (from tips n+1 to 2n-1)
  ACE2 <- data.frame(as.numeric(rownames(ACE)),ACE) 
  names(ACE2)[names(ACE2)=="as.numeric.rownames.ACE.."] <- "X1"
  MRCA_ACE <- merge (ACE2, mrca, by ="X1") #merge by nodes
  MRCA_ACE2<-MRCA_ACE[order(MRCA_ACE$X2),] # order tip from 1
  RATE <-cbind(MRCA_ACE2,data)
  RATE$Rate_BM <- with(RATE,abs(data-BMace1)/Brtime)
  RATE$Rate_OU <- with(RATE,abs(data-OUace1)/Brtime)
  RATE$Rate_LA <- with(RATE,abs(data-LAace1)/Brtime)
  RATE2<-RATE[order(RATE$X2),]
  rownames(RATE2) <- tree$tip.label
  return(list(RATE2,AIC1))
}